Index: extensions/dict_dcca_3gpp/add_avps.c
===================================================================
--- extensions/dict_dcca_3gpp/add_avps.c	(revision 1518)
+++ extensions/dict_dcca_3gpp/add_avps.c	(revision 1519)
@@ -6419,5 +6419,5 @@
 
 	/*==================================================================*/
-	/* Table A.7.3.1.1: S9a specific Diameter AVPs                      */
+	/* 3GPP TS 29.215 Table A.7.3.1.1: S9a specific Diameter AVPs       */
 	/*==================================================================*/
 
@@ -6436,5 +6436,5 @@
 
 	/*==================================================================*/
-	/* Table A.8.3.1.1: S9a* specific Diameter AVPs                     */
+	/* 3GPP TS 29.215 Table A.8.3.1.1: S9a* specific Diameter AVPs      */
 	/*==================================================================*/
 
@@ -14789,4 +14789,57 @@
 
 	/*==================================================================*/
+	/* 3GPP TS 29.389 V15.1.0 (2019-09)                                 */
+	/* Inter-V2X Control Function Signalling aspects (V6);              */
+	/* Stage 3                                                          */
+	/*                                                                  */
+	/* From 3GPP 29389-f10.doc                                          */
+	/*==================================================================*/
+
+	/*==================================================================*/
+	/* 3GPP TS 29.389 Table 6.3.1-1: V6 specific Diameter AVPs          */
+	/*                                                                  */
+	/* Fix: All AVPs were missing M and V; assume MUST for both.        */
+	/*==================================================================*/
+
+	/* V2X-Authorization-Data, Grouped, code 4700, section 6.3.2        */
+	{
+		struct dict_avp_data data = {
+			4700,	/* Code */
+			10415,	/* Vendor */
+			"V2X-Authorization-Data",	/* Name */
+			AVP_FLAG_VENDOR |AVP_FLAG_MANDATORY,	/* Fixed flags */
+			AVP_FLAG_VENDOR |AVP_FLAG_MANDATORY,	/* Fixed flag values */
+			AVP_TYPE_GROUPED	/* base type of data */
+		};
+		CHECK_dict_new(DICT_AVP, &data, NULL, NULL);
+	};
+
+	/* V2X-Permission-in-VPLMN, Unsigned32, code 4701, section 6.3.3    */
+	{
+		struct dict_avp_data data = {
+			4701,	/* Code */
+			10415,	/* Vendor */
+			"V2X-Permission-in-VPLMN",	/* Name */
+			AVP_FLAG_VENDOR |AVP_FLAG_MANDATORY,	/* Fixed flags */
+			AVP_FLAG_VENDOR |AVP_FLAG_MANDATORY,	/* Fixed flag values */
+			AVP_TYPE_UNSIGNED32	/* base type of data */
+		};
+		CHECK_dict_new(DICT_AVP, &data, NULL, NULL);
+	};
+
+	/* V2X-Application-Server, Grouped, code 4702, section 6.3.4        */
+	{
+		struct dict_avp_data data = {
+			4702,	/* Code */
+			10415,	/* Vendor */
+			"V2X-Application-Server",	/* Name */
+			AVP_FLAG_VENDOR |AVP_FLAG_MANDATORY,	/* Fixed flags */
+			AVP_FLAG_VENDOR |AVP_FLAG_MANDATORY,	/* Fixed flag values */
+			AVP_TYPE_GROUPED	/* base type of data */
+		};
+		CHECK_dict_new(DICT_AVP, &data, NULL, NULL);
+	};
+
+	/*==================================================================*/
 	/* 3GPP TS 29.468 V15.8.0 (2019-12)                                 */
 	/* Group Communication System Enablers for LTE (GCSE_LTE);          */
Index: extensions/dict_dcca_3gpp/dict_dcca_3gpp.csv
===================================================================
--- extensions/dict_dcca_3gpp/dict_dcca_3gpp.csv	(revision 1518)
+++ extensions/dict_dcca_3gpp/dict_dcca_3gpp.csv	(revision 1519)
@@ -761,10 +761,10 @@
 DRA-Binding,2208,5.3.x,Enumerated,V,P,,M
 #=,,,,,,,
-# Table A.7.3.1.1: S9a specific Diameter AVPs,,,,,,,
+# 3GPP TS 29.215 Table A.7.3.1.1: S9a specific Diameter AVPs,,,,,,,
 #=,,,,,,,
 #,,,,,,,
 PCRF-Address,2207,A.7.3.1.1,DiameterIdentity,"V,M",P,,
 #=,,,,,,,
-# Table A.8.3.1.1: S9a* specific Diameter AVPs,,,,,,,
+# 3GPP TS 29.215 Table A.8.3.1.1: S9a* specific Diameter AVPs,,,,,,,
 #=,,,,,,,
 #,,,,,,,
@@ -1716,4 +1716,23 @@
 V2X-Update-Flags,4601,6.3.4,Unsigned32,"M,V",,,
 V2X-Notify-Flags,4602,6.3.5,Unsigned32,"M,V",,,
+,,,,,,,
+@standard,3GPP TS 29.389,,,,,,
+#=,,,,,,,
+# 3GPP TS 29.389 V15.1.0 (2019-09),,,,,,,
+# Inter-V2X Control Function Signalling aspects (V6);,,,,,,,
+# Stage 3,,,,,,,
+# ,,,,,,,
+# From 3GPP 29389-f10.doc,,,,,,,
+#=,,,,,,,
+#,,,,,,,
+#=,,,,,,,
+# 3GPP TS 29.389 Table 6.3.1-1: V6 specific Diameter AVPs,,,,,,,
+# ,,,,,,,
+# Fix: All AVPs were missing M and V; assume MUST for both.,,,,,,,
+#=,,,,,,,
+#,,,,,,,
+V2X-Authorization-Data,4700,6.3.2,Grouped,"M,V",,,
+V2X-Permission-in-VPLMN,4701,6.3.3,Unsigned32,"M,V",,,
+V2X-Application-Server,4702,6.3.4,Grouped,"M,V",,,
 ,,,,,,,
 @standard,3GPP TS 29.468,,,,,,