Index: extensions/rt_redirect/redir_entries.c
===================================================================
--- extensions/rt_redirect/redir_entries.c	(revision 740)
+++ extensions/rt_redirect/redir_entries.c	(revision 1259)
@@ -43,15 +43,15 @@
 {
 	int i;
-	
+
 	TRACE_ENTRY("");
-	
+
 	/* redirects_usages */
 	memset(&redirects_usages, 0, sizeof(redirects_usages));
-	
+
 	for (i = 0; i <= H_U_MAX; i++) {
 		CHECK_POSIX( pthread_rwlock_init( &redirects_usages[i].lock, NULL) );
 		fd_list_init( &redirects_usages[i].sentinel, &redirects_usages[i] );
 	}
-	
+
 	/* initialize the scores */
 	redirects_usages[ DONT_CACHE		].score = FD_SCORE_REDIR_ONCE;
@@ -73,21 +73,21 @@
 	os0_t s;
 	size_t l;
-	
+
 	TRACE_ENTRY("%p %p %d %p %p %zd %p %zd", e, targets, rhu, qry, nh, nhlen, oh, ohlen)
 	ASSERT(e && targets && (rhu <= H_U_MAX) && qry && nh && nhlen && oh && ohlen);
-	
+
 	CHECK_MALLOC( entry = malloc(sizeof(struct redir_entry)) );
 	memset(entry, 0, sizeof(struct redir_entry));
-	
+
 	entry->eyec = REDIR_ENTRY_EYEC;
-	
+
 	CHECK_MALLOC( entry->from.s = os0dup(nh, nhlen) );
 	entry->from.l = nhlen;
-	
+
 	fd_list_init(&entry->target_peers_list, entry);
 	fd_list_move_end(&entry->target_peers_list, targets);
-	
+
 	fd_list_init(&entry->exp_list, entry);
-	
+
 	entry->type = rhu;
 	fd_list_init(&entry->redir_list, entry);
@@ -97,5 +97,5 @@
 			entry->data.message.msg = qry;
 			break;
-			
+
 		case ALL_SESSION:
 			{
@@ -114,5 +114,5 @@
 			}
 			break;
-		
+
 		case ALL_REALM:
 			{
@@ -132,5 +132,5 @@
 			}
 			break;
-				
+
 		case REALM_AND_APPLICATION:
 			{
@@ -156,5 +156,5 @@
 			}
 			break;
-				
+
 		case ALL_APPLICATION:
 			{
@@ -164,10 +164,10 @@
 			}
 			break;
-			
+
 		case ALL_HOST:
 			CHECK_MALLOC( entry->data.host.s = os0dup(oh, ohlen) );
 			entry->data.host.l = ohlen;
 			break;
-			
+
 		case ALL_USER:
 			{
@@ -187,10 +187,10 @@
 			}
 			break;
-		
+
 		default:
 			ASSERT(0);
 			return EINVAL;
 	}
-	
+
 	/* We're done */
 	*e = entry;
@@ -203,5 +203,5 @@
 	unsigned long v1 = (unsigned long) d1->message.msg;
 	unsigned long v2 = (unsigned long) d2->message.msg;
-	if (v1 > v2) 
+	if (v1 > v2)
 		return 1;
 	if (v1 < v2)
@@ -211,7 +211,7 @@
 /* Compare two applications (REALM_AND_APPLICATION and ALL_APPLICATION) */
 static int compare_entries_appl(union matchdata * d1, union matchdata * d2) {
-	if (d1->app.a > d2->app.a) 
+	if (d1->app.a > d2->app.a)
 		return 1;
-	if (d1->app.a < d2->app.a) 
+	if (d1->app.a < d2->app.a)
 		return -1;
 	return 0;
@@ -238,11 +238,11 @@
 {
 	struct fd_list * li;
-	
+
 	TRACE_ENTRY("%p", e);
 	CHECK_PARAMS(e && (e->eyec == REDIR_ENTRY_EYEC));
-	
+
 	/* Write-Lock the line */
 	CHECK_POSIX( pthread_rwlock_wrlock( RWLOCK_REDIR(e) ) );
-	
+
 	for (li = redirects_usages[e->type].sentinel.next; li != &redirects_usages[e->type].sentinel; li = li->next) {
 		struct redir_entry * n = li->o;
@@ -251,7 +251,7 @@
 			break;
 	}
-	
+
 	fd_list_insert_before(li, &e->redir_list);
-	
+
 	/* unLock the line */
 	CHECK_POSIX( pthread_rwlock_unlock( RWLOCK_REDIR(e) ) );
@@ -265,5 +265,5 @@
 	TRACE_ENTRY("%p", e);
 	CHECK_PARAMS(e && (e->eyec == REDIR_ENTRY_EYEC));
-	
+
 	/* If the entry is linked, lock the rwlock also */
 	if (!FD_IS_LIST_EMPTY(&e->redir_list)) {
@@ -272,17 +272,17 @@
 		CHECK_POSIX( pthread_rwlock_unlock( RWLOCK_REDIR(e) ) );
 	}
-	
+
 	/* Now unlink from other list */
 	fd_list_unlink(&e->exp_list);
-	
+
 	/* Empty the targets list */
 	while (!FD_IS_LIST_EMPTY(&e->target_peers_list)) {
 		struct redir_host * h = (struct redir_host *)e->target_peers_list.next->o;
-		
+
 		fd_list_unlink(&h->chain);
 		free(h->id);
 		free(h);
 	}
-	
+
 	/* Now we can destroy the data safely */
 	switch (e->type) {
@@ -312,7 +312,7 @@
 			return EINVAL;
 	}
-	
+
 	free(e->from.s);
-	
+
 	free(e);
 	return 0;
Index: extensions/rt_redirect/redir_expiry.c
===================================================================
--- extensions/rt_redirect/redir_expiry.c	(revision 740)
+++ extensions/rt_redirect/redir_expiry.c	(revision 1259)
@@ -41,10 +41,10 @@
 /* Entries by their ascending expiration date, to accelerate the work of the expire thread */
 static struct fd_list  expire_list = FD_LIST_INITIALIZER(expire_list);
-static pthread_cond_t  exp_cnd  = PTHREAD_COND_INITIALIZER; 
+static pthread_cond_t  exp_cnd  = PTHREAD_COND_INITIALIZER;
 
 pthread_mutex_t redir_exp_peer_lock = PTHREAD_MUTEX_INITIALIZER;
 
 /* The thread that handles expired entries cleanup. */
-void * redir_exp_thr_fct(void * arg) 
+void * redir_exp_thr_fct(void * arg)
 {
 	fd_log_threadname ( "Redirects/expire" );
@@ -53,9 +53,9 @@
 	CHECK_POSIX_DO( pthread_mutex_lock(&redir_exp_peer_lock),  goto fatal_error );
 	pthread_cleanup_push( fd_cleanup_mutex, &redir_exp_peer_lock );
-	
+
 	do {
 		struct timespec	now;
 		struct redir_entry * first;
-again:		
+again:
 		/* Check if there are expiring entries available */
 		if (FD_IS_LIST_EMPTY(&expire_list)) {
@@ -65,8 +65,8 @@
 			goto again;
 		}
-		
+
 		/* Get the pointer to the entry that expires first */
 		first = (struct redir_entry *)(expire_list.next->o);
-		
+
 		/* Get the current time */
 		CHECK_SYS_DO(  clock_gettime(CLOCK_REALTIME, &now),  break  );
@@ -74,22 +74,22 @@
 		/* If first session is not expired, we just wait until it happens */
 		if ( TS_IS_INFERIOR( &now, &first->timeout ) ) {
-			
-			CHECK_POSIX_DO2(  pthread_cond_timedwait( &exp_cnd, &redir_exp_peer_lock, &first->timeout ),  
+
+			CHECK_POSIX_DO2(  pthread_cond_timedwait( &exp_cnd, &redir_exp_peer_lock, &first->timeout ),
 					ETIMEDOUT, /* ETIMEDOUT is a normal error, continue */,
 					/* on other error, */ break );
-	
+
 			/* on wakeup, loop */
 			goto again;
 		}
-		
+
 		/* Now, the first entry in the list is expired; destroy it */
-		
+
 		CHECK_FCT_DO( redir_entry_destroy( first ), break );
-		
+
 	} while (1);
-	
+
 	pthread_cleanup_pop( 0 );
 	CHECK_POSIX_DO( pthread_mutex_unlock(&redir_exp_peer_lock),  );
-	
+
 fatal_error:
 	TRACE_DEBUG(INFO, "A system error occurred in redirect module! Expiry thread is terminating...");
@@ -104,31 +104,31 @@
 	TRACE_ENTRY("%p %d", e, duration);
 	CHECK_PARAMS(e && (e->eyec == REDIR_ENTRY_EYEC) && duration );
-	
+
 	/* Unlink in case it was already set before */
 	fd_list_unlink(&e->exp_list);
-	
+
 	/* Get current time */
 	CHECK_SYS(  clock_gettime(CLOCK_REALTIME, &e->timeout)  );
-	
+
 	/* Add the duration */
 	e->timeout.tv_sec += duration;
-	
+
 	/* now search the next element in the list */
 	for (li = expire_list.next; li != &expire_list; li = li->next) {
 		struct redir_entry * n = li->o;
-		
+
 		if ( TS_IS_INFERIOR( &e->timeout, &n->timeout ) )
 			break;
-	
+
 	}
-	
+
 	/* Insert before this element */
 	fd_list_insert_before(li, &e->exp_list);
-	
+
 	/* Signal the expiry thread if needed */
 	if (e->exp_list.prev == &expire_list) { /* it is the first element */
 		CHECK_POSIX( pthread_cond_signal(&exp_cnd) );
 	}
-	
+
 	/* Done */
 	return 0;
Index: extensions/rt_redirect/redir_fwd.c
===================================================================
--- extensions/rt_redirect/redir_fwd.c	(revision 1127)
+++ extensions/rt_redirect/redir_fwd.c	(revision 1259)
@@ -59,14 +59,14 @@
 	int nbrh = 0;
 	struct redir_entry * entry;
-	
+
 	TRACE_ENTRY("%p %p", cbdata, msg);
-	
+
 	CHECK_PARAMS(msg && *msg);
-	
+
 	m = *msg;
-	
+
 	/* First get the header */
 	CHECK_FCT( fd_msg_hdr(m, &hdr) );
-	
+
 	/* Check if we have an error */
 	ASSERT(!(hdr->msg_flags & CMD_FLAG_REQUEST));
@@ -75,10 +75,10 @@
 		return 0;
 	}
-	
+
 	/* Now get the AVPs we are interested in */
 	CHECK_FCT(  fd_msg_browse(m, MSG_BRW_FIRST_CHILD, &avp, NULL)  );
 	while (avp) {
 		struct avp_hdr * ahdr;
-			
+
 		CHECK_FCT(  fd_msg_avp_hdr( avp, &ahdr )  );
 		if (! (ahdr->avp_flags & AVP_FLAG_VENDOR)) {
@@ -90,5 +90,5 @@
 					a_oh = ahdr->avp_value;
 					break;
-					
+
 				case AC_RESULT_CODE:
 					/* Parse this AVP */
@@ -96,5 +96,5 @@
 					ASSERT( ahdr->avp_value );
 					a_rc = ahdr->avp_value;
-					
+
 					if (a_rc->u32 != ER_DIAMETER_REDIRECT_INDICATION) {
 						/* It is not a REDIRECT error, we don't do anything */
@@ -102,5 +102,5 @@
 					}
 					break;
-					
+
 				case AC_REDIRECT_HOST:
 					{
@@ -112,12 +112,12 @@
 						int	 l4 = 0;
 						char	 proto = 0;
-						
+
 						/* Parse this AVP */
 						CHECK_FCT( fd_msg_parse_dict ( avp, fd_g_config->cnf_dict, NULL ) );
 						ASSERT( ahdr->avp_value );
-						
+
 						nbrh++;
-						
-						CHECK_FCT_DO( fd_os_parse_DiameterURI(ahdr->avp_value->os.data, ahdr->avp_value->os.len, 
+
+						CHECK_FCT_DO( fd_os_parse_DiameterURI(ahdr->avp_value->os.data, ahdr->avp_value->os.len,
 									&id, &len, &secure, &port, &l4, &proto),
 							{
@@ -125,5 +125,5 @@
 								break;
 							} );
-						
+
 						/* Now check if the transport & protocol are supported */
 						if (proto && (proto != 'd')) {
@@ -137,7 +137,7 @@
 							break;
 						}
-						
+
 						/* It looks OK, save this entry. */
-						
+
 						CHECK_MALLOC( h = malloc(sizeof(struct redir_host)) );
 						memset(h, 0, sizeof(struct redir_host));
@@ -146,5 +146,5 @@
 						h->len = len;
 						/* later: secure, port */
-						
+
 						/* The list is kept ordered by id so that it is faster to compare to candidates later */
 						for (li = task.rh.next; li != &task.rh; li = li->next) {
@@ -183,5 +183,5 @@
 		CHECK_FCT(  fd_msg_browse(avp, MSG_BRW_NEXT, &avp, NULL)  );
 	}
-	
+
 	/* Check we have received the necessary information */
 	if (!a_rc) {
@@ -189,10 +189,10 @@
 		goto out;
 	}
-	
+
 	if (!a_oh) {
 		TRACE_DEBUG(FULL, "Invalid Diameter answer without an Origin-Host AVP, Redirect module gave up");
 		goto out;
 	}
-	
+
 	if (FD_IS_LIST_EMPTY(&task.rh)) {
 		TRACE_DEBUG(FULL, "Diameter answer with a DIAMETER_REDIRECT_INDICATION Result-Code AVP but no valid/supported Redirect-Host AVP, Redirect module gave up");
@@ -204,12 +204,12 @@
 		goto out;
 	}
-	
+
 	/* It looks like we can process the Redirect indication */
-	
+
 	/* Search for the peers we already know */
 	for (li = task.rh.next; li != &task.rh; li = li->next) {
 		struct redir_host * h = li->o;
 		struct peer_hdr * peer;
-		
+
 		CHECK_FCT( fd_peer_getbyid( h->id, h->len, 1, &peer ) );
 		if (peer) {
@@ -221,17 +221,17 @@
 		}
 	}
-	
+
 	TRACE_DEBUG(FULL, "Redirect module: received %d Redirect-Hosts, %d are known peers, %d have an OPEN connection", nbrh, known, actives);
-	
+
 	/* in this version, we only redirect when there are known active peers. TODO: add new peers via fd_peer_add when no active peer is available */
-	
+
 	if (!actives) {
 		TRACE_DEBUG(INFO, "Unable to comply to Redirect indication: none of the peers included is in OPEN state");
 		goto out;
 	}
-	
+
 	/* From this point, we will re-send the query to a different peer, so stop forwarding the answer here */
 	*msg = NULL;
-	
+
 	/* Get the query's routing data & add the new error */
 	CHECK_FCT( fd_msg_answ_getq(m, &q) );
@@ -239,8 +239,8 @@
 	CHECK_FCT( fd_msg_source_get( m, &nh, &nhlen ) );
 	CHECK_FCT( fd_rtd_error_add(rtd, nh, nhlen, a_oh->os.data, a_oh->os.len, a_rc->u32, NULL, NULL) );
-	
+
 	/* Create a redir_rule  */
 	CHECK_FCT( redir_entry_new(&entry, &task.rh, task.rhu, q, nh, nhlen, a_oh->os.data, a_oh->os.len) );
-		
+
 	CHECK_POSIX(  pthread_mutex_lock(&redir_exp_peer_lock)  );
 	/* Insert in the split list */
@@ -253,10 +253,10 @@
 	CHECK_FCT( fd_msg_answ_detach(m) );
 	CHECK_FCT( fd_msg_free(m) );
-	
+
 	/* Send it */
 	CHECK_FCT( fd_msg_send(&q, NULL, NULL) );
-	
+
 	/* Done! */
-	
+
 out:
 	while (!FD_IS_LIST_EMPTY(&task.rh)) {
@@ -266,5 +266,5 @@
 		free(h);
 	}
-		
+
 	return 0;
 
Index: extensions/rt_redirect/redir_out.c
===================================================================
--- extensions/rt_redirect/redir_out.c	(revision 1216)
+++ extensions/rt_redirect/redir_out.c	(revision 1259)
@@ -41,9 +41,9 @@
 {
 	TRACE_ENTRY("%d %p %p %p", type, msg, data, nodata);
-	
+
 	/* Initialize the data area */
 	memset(data, 0, sizeof(union matchdata));
 	*nodata = 0;
-	
+
 	/* Now, find the appropriate information, depending on type */
 	switch (type) {
@@ -51,5 +51,5 @@
 			data->message.msg = msg;
 			break;
-			
+
 		case ALL_SESSION:
 			{
@@ -65,5 +65,5 @@
 			}
 			break;
-		
+
 		case ALL_REALM:
 			{
@@ -82,5 +82,5 @@
 			}
 			break;
-				
+
 		case REALM_AND_APPLICATION:
 			{
@@ -96,5 +96,5 @@
 					data->realm_app.s = ahdr->avp_value->os.data;
 					data->realm_app.l = ahdr->avp_value->os.len;
-					
+
 					/* and then the application */
 					{
@@ -107,5 +107,5 @@
 			}
 			break;
-				
+
 		case ALL_APPLICATION:
 			{
@@ -116,9 +116,9 @@
 			}
 			break;
-			
+
 		case ALL_HOST:
 				/* This is more complex, we need to match with all candidates in each rule, it'll be done later */
 			break;
-			
+
 		case ALL_USER:
 			{
@@ -137,5 +137,5 @@
 			}
 			break;
-		
+
 		default:
 			ASSERT(0);
@@ -153,20 +153,20 @@
 	struct rtd_candidate * c_oh = NULL;
 	int cmp;
-	
+
 	TRACE_ENTRY("%p %p %p", e, msg, candidates);
 	ASSERT( e && msg && candidates );
-	
+
 	if (FD_IS_LIST_EMPTY(candidates)) {
 		TRACE_DEBUG(ANNOYING, "Skip Redirect rule since candidates list is empty");
 		return 0;
 	}
-	
+
 	/* Now search common peers between e->target_peers_list and candidates */
 	TRACE_DEBUG(ANNOYING, "Message %p matches a Redirect rule (t:%d, @%p), processing candidates list", msg, e->type, e);
-	
+
 	/* First, decrease the score of the host that we received the previous Redirect from, in case it is in the list */
 	for (lic = candidates->next; lic != candidates; lic = lic->next) {
 		struct rtd_candidate * cand = (struct rtd_candidate *) lic;
-		
+
 		/* Special case: ALL_HOST rules: we decrease the score of the Origin-Host if present */
 		if (e->type == ALL_HOST) {
@@ -179,5 +179,5 @@
 			}
 		}
-		
+
 		cmp = fd_os_cmp(cand->diamid, cand->diamidlen, e->from.s, e->from.l);
 		if (!cmp) {
@@ -185,24 +185,24 @@
 			cand->score += FD_SCORE_SENT_REDIRECT;
 		}
-		
-	}
-	
+
+	}
+
 	if ((e->type == ALL_HOST) && (c_oh == NULL)) {
 		/* The rule does not apply, we're done */
 		return 0;
 	}
-	
+
 	/* for each candidate, if it is found in the target_peers list, we add the rule's score to this candidate */
 	for (lic = candidates->next; lic != candidates; lic = lic->next) {
 		/* the candidates list is not guaranteed to be ordered at this time, so we cannot avoid the two imbricated loops */
 		struct rtd_candidate * cand = (struct rtd_candidate *) lic;
-		
+
 		/* Is this candidate in the "Redirect-Host" list ? We must search caseinsentive here. */
 		for (lirh = e->target_peers_list.next; lirh != &e->target_peers_list; lirh = lirh->next) {
 			struct redir_host * host = lirh->o;
 			int cont;
-			
+
 			cmp = fd_os_almostcasesrch( cand->diamid, cand->diamidlen, host->id, host->len, &cont );
-			
+
 			if (cmp == 0) {
 				TRACE_DEBUG(FULL, "Redirect msg %p: peer '%.*s' += %d (rule t:%d @%p)", msg, (int)cand->diamidlen, cand->diamid, redirects_usages[e->type].score, e->type, e);
@@ -214,5 +214,5 @@
 		}
 	}
-	
+
 	return 0;
 }
@@ -224,7 +224,7 @@
 	int i, ret = 0;
 	struct msg * msg = *pmsg;
-	
+
 	TRACE_ENTRY("%p %p %p", cbdata, msg, candidates);
-	
+
 	for (i = 0; i <= H_U_MAX; i++) {
 		/* Lock the line. We write lock in case of DONT_CACHE so we can directly unlink the entry. read in other cases is sufficient */
@@ -234,12 +234,12 @@
 			CHECK_POSIX( pthread_rwlock_rdlock( &redirects_usages[i].lock ) );
 		}
-		
+
 		if (!FD_IS_LIST_EMPTY(&redirects_usages[i].sentinel)) {
 			union matchdata data;
 			int nodata; /* The message does not allow to apply this rule, skip */
-			
+
 			/* Retrieve the data that may match in the message */
 			CHECK_FCT_DO( ret = get_data_to_match(i, msg, &data, &nodata), goto out );
-			
+
 			/* If this message may match some of our rules */
 			if (!nodata) {
@@ -248,5 +248,5 @@
 				for (li = redirects_usages[i].sentinel.next; li != &redirects_usages[i].sentinel; li = li->next) {
 					struct redir_entry * e = li->o;
-					
+
 					/* Does it match ? */
 					if (i != ALL_HOST) { /* this one is an exception, we handle it separately */
@@ -257,25 +257,25 @@
 							break;
 					}
-					
+
 					/* This rule matches (or we are in ALL_HOST), apply */
 					CHECK_FCT_DO( ret = apply_rule(e, msg, candidates), goto out );
-					
+
 					/* If this was a DONT_CACHE rule, we unlink it, so that it will not be used again */
 					if (i == DONT_CACHE) {
 						li=li->prev;
 						fd_list_unlink( li->next );
-						/* We cannot delete here without taking the mutex, which would mean we have first to release the lock... 
+						/* We cannot delete here without taking the mutex, which would mean we have first to release the lock...
 							just let expiry garbage collet the rule */
 					}
 				}
 			}
-		
-		}
-out:		
+
+		}
+out:
 		CHECK_POSIX( pthread_rwlock_unlock( &redirects_usages[i].lock ) );
 		if (ret)
 			return ret;
 	}
-	
+
 	return 0;
 }
Index: extensions/rt_redirect/rt_redir.c
===================================================================
--- extensions/rt_redirect/rt_redir.c	(revision 740)
+++ extensions/rt_redirect/rt_redir.c	(revision 1259)
@@ -47,5 +47,5 @@
 {
 	TRACE_ENTRY("");
-	
+
 	/* Dictionary objects */
 	CHECK_FCT(  fd_dict_search( fd_g_config->cnf_dict, DICT_AVP, AVP_BY_NAME, "Destination-Realm", &redir_dict_dr, ENOENT)  );
@@ -54,8 +54,8 @@
 	/* Initialize the entries array */
 	CHECK_FCT( redir_entry_init() );
-	
+
 	/* Start the expire thread */
 	CHECK_POSIX( pthread_create( &exp_thr, NULL, redir_exp_thr_fct, NULL ) );
-	
+
 	/* Register the callback that receives the answers and processes when it contains a Redirect indication. */
 	CHECK_FCT( fd_rt_fwd_register ( redir_fwd_cb, NULL, RT_FWD_ANS, &fwd_hdl ) );
@@ -73,5 +73,5 @@
 {
 	int i;
-	
+
 	/* Unregister the callbacks */
 	if (fwd_hdl) {
@@ -81,8 +81,8 @@
 		CHECK_FCT_DO( fd_rt_out_unregister(out_hdl, NULL), );
 	}
-	
+
 	/* Stop the expiry thread */
 	CHECK_FCT_DO( fd_thr_term(&exp_thr), );
-	
+
 	/* Empty all entries */
 	CHECK_POSIX_DO( pthread_mutex_lock(&redir_exp_peer_lock),   );
@@ -98,5 +98,5 @@
 	}
 	CHECK_POSIX_DO( pthread_mutex_unlock(&redir_exp_peer_lock),   );
-	
+
 	return;
 }
Index: extensions/rt_redirect/rt_redir.h
===================================================================
--- extensions/rt_redirect/rt_redir.h	(revision 1235)
+++ extensions/rt_redirect/rt_redir.h	(revision 1259)
@@ -39,5 +39,5 @@
 /* There are 2 locks in this module. The priority is established as follow to avoid deadlocks:
 exp_peer mutex > usages rwlock.
-(e.g., the rwlock can be taken while holding the mutex, but not the other way) 
+(e.g., the rwlock can be taken while holding the mutex, but not the other way)
 */
 
@@ -59,12 +59,12 @@
 /* Expiration time set for DONT_CACHE tasks, so that the entry is found when the code is called back */
 #define DEFAULT_EXPIRE_TIME 10 /* seconds */
-	
+
 /* Structure to store a parsed Redirect-Host */
 struct redir_host {
-	struct fd_list chain; 
-	
+	struct fd_list chain;
+
 	DiamId_t id;	/* malloc'd */
 	size_t	 len;
-	/* We don't use the following yet because we don't support dynamic new connections 
+	/* We don't use the following yet because we don't support dynamic new connections
 	int 	 secure;
 	uint16_t port;
@@ -117,10 +117,10 @@
 	} user;
 };
-	
+
 
 /* Structure to store a Redirect indication */
 struct redir_entry {
 	uint32_t eyec; /* must be REDIR_ENTRY_EYEC, used for debug only */
-	
+
 	struct {
 		os0_t s; /* alloc'd, must be freed */
@@ -132,5 +132,5 @@
 	struct timespec  timeout;  /* When does this entry expires? */
 	struct fd_list   exp_list; /* chain in the expire_list list, ordered by expiration date, protected by exp_peer_lock */
-	
+
 	enum redir_h_u type;  /* Type of this entry */
 	struct fd_list redir_list; /* link in redirects_usages lists. Lists are ordered by the data value. Protected by rw locks */